// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{Path, PathElement};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlPathBar")]
    pub struct PathBar(Object<ffi::DzlPathBar, ffi::DzlPathBarClass>) @extends gtk::Box, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Orientable;

    match fn {
        type_ => || ffi::dzl_path_bar_get_type(),
    }
}

impl PathBar {
    #[doc(alias = "dzl_path_bar_new")]
    pub fn new() -> PathBar {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_path_bar_new()).unsafe_cast() }
    }

    #[doc(alias = "dzl_path_bar_get_path")]
    #[doc(alias = "get_path")]
    pub fn path(&self) -> Option<Path> {
        unsafe { from_glib_none(ffi::dzl_path_bar_get_path(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_path_bar_set_path")]
    pub fn set_path(&self, path: &Path) {
        unsafe {
            ffi::dzl_path_bar_set_path(self.to_glib_none().0, path.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_path_bar_set_selected_index")]
    pub fn set_selected_index(&self, index: u32) {
        unsafe {
            ffi::dzl_path_bar_set_selected_index(self.to_glib_none().0, index);
        }
    }

    #[doc(alias = "element-selected")]
    pub fn connect_element_selected<F: Fn(&Self, &Path, &PathElement) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn element_selected_trampoline<
            F: Fn(&PathBar, &Path, &PathElement) + 'static,
        >(
            this: *mut ffi::DzlPathBar,
            object: *mut ffi::DzlPath,
            p0: *mut ffi::DzlPathElement,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                &from_glib_borrow(this),
                &from_glib_borrow(object),
                &from_glib_borrow(p0),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"element-selected\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    element_selected_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "populate-menu")]
    pub fn connect_populate_menu<F: Fn(&Self, &Path, &PathElement, &gio::Menu) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn populate_menu_trampoline<
            F: Fn(&PathBar, &Path, &PathElement, &gio::Menu) + 'static,
        >(
            this: *mut ffi::DzlPathBar,
            object: *mut ffi::DzlPath,
            p0: *mut ffi::DzlPathElement,
            p1: *mut gio::ffi::GMenu,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                &from_glib_borrow(this),
                &from_glib_borrow(object),
                &from_glib_borrow(p0),
                &from_glib_borrow(p1),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"populate-menu\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    populate_menu_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "path")]
    pub fn connect_path_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_path_trampoline<F: Fn(&PathBar) + 'static>(
            this: *mut ffi::DzlPathBar,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::path\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_path_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for PathBar {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for PathBar {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("PathBar")
    }
}
